<h2>2 - Templates</h2>

<p>Explains templates. This application uses the &amp;lt;Include&amp;gt;
tag to insert the same header file at the beginning of each
template and to break the templates into sub templates. It shows
how to include the javascript code and the stylesheet of each
template. It also explains the use of the framework comments and
the difference between them and the HTML comments. Explains how to
debug the template structure.</p>
<span class="button">
  <a href="{{SAPPS_URL}}app2/" target= "_blank">Test</a>
</span>
<span class="button">
  <a href="{{SAPPS_URL}}app2/browse.php" target="_blank">Browse</a>
</span>
<!--#
<span class="button">
  <a href="{{HOME_URL}}get/app2.tar.gz">Download</a>
</span>
#-->
<br />

<hr />

<h3><a name="toc">Table of Contents</a></h3>

<ul>
  <li>
    <a href="#templates">Templates</a>

    <ol>
      <li><a href="#variables">Template Variables</a></li>

      <li><a href="#include">The &amp;lt;Include&amp;gt; tag</a></li>

      <li><a href="#comments">Comments</a></li>

      <li><a href="#including">JavaScript code and stylesheet of a
      template</a></li>
    </ol>
  </li>

  <li><a href="#study">Study the sample</a></li>

  <li>
    <a href="#exercises">Exercises</a>

    <ol>
      <li><a href="#exercise_1">Modify page2.html and
      page3.html</a></li>

      <li><a href="#exercise_2">Rename folder <em>img</em> to
      <em>images</em></a></li>

      <li><a href="#exercise_3">Divide Page1 further into
      subtemplates</a></li>

      <li><a href="#exercise_4">Move Page1 to a new folder</a></li>

      <li><a href="#exercise_5">Change the styles of the
      page1_content</a></li>

      <li><a href="#exercise_6">Move template tpl_2.html and its
      related files to folder <em>page3/tpl_2/</em></a></li>

      <li><a href="#exercise_7">Debug templates</a></li>

      <li><a href="#exercise_8">Think about it</a></li>
    </ol>
  </li>
</ul>
<hr />

<a name="templates"></a>

<h3>Templates</h3>

<p>Templates are pieces of HTML code, that are used or combined by
the framework to generate the HTML pages that are sent to the
browser.</p>

<a name="variables"></a>

<h4>1 - Template variables</h4>

<p>The templates may contain variables inside them (called
"template variables"), which are replaced by the framework with
their string values. The variables inside a template are denoted by
double curly braces: <strong>{{#tpl_var}}</strong>.</p>

<p>See this 
<a href="javascript:codeReview('{{SAPPS_PATH}}app2/templates/page3/page3.html','8,11,13,15')">
example</a>. The <strong>{{#TPL_URL}}</strong> variable in line 8 contains
the URL of the folder <em>templates</em>, which in this case is
<em>{{SAPPS_URL}}app2/templates/</em>. The <strong>{{#TPL}}</strong>
variable in lines 11 and 15 contains the path in the server of the folder
templates, e.g. <em>/var/www/html{{SAPPS_URL}}app2/templates/</em>.
Both of them are declared in the file 
<a href="javascript:codeReview('{{SAPPS_PATH}}app2/config/const.Paths.php','6,7')">
<em>config/const.Paths.php</em></a>. The variable <strong>{{#./}}</strong>
in line 13 is a special framework variable that always contains the
path of the current folder, i.e. the folder of the current
file.</p>

<a name="include"></a>

<h4>2 - The &amp;lt;include&amp;gt; tag</h4>

<p>The templates may also contain some extra tags, which are not
HTML tags. These tags are recognized and processed by the
framework. One of them is the &amp;lt;include&amp;gt; tag, which is used to
include another template inside the current template:</p>
<pre>
    &amp;lt;include src="file_to_be_included" /&amp;gt;
</pre>

<p>It is a very useful tag, because it allows to divide pages into
subtemplates, which results in a better structured application,
provides modularity (the graphical designer can work with smaller
pieces of code), and re-usability (templates are easier to be reused
in other pages or other applications). See how it is used in this
<a href="javascript:codeReview('{{SAPPS_PATH}}app2/templates/page3/page3.html','11,13,15')">
example</a>.</p>

<a name="comments"></a>

<h4>3 - Comments</h4>

<p>The templates may contain some special comments as well:</p>
<pre>
    &amp;lt;!--# Framework comments --&amp;gt;
</pre>

<p>These comments are like HTML comments but they have a diesis 
<strong>#</strong> at the opening mark. These comments 
are not processed (are skipped, ignored) by the framework and are not 
displayed in the HTML page that is generated. 
<a href="javascript:codeReview('{{SAPPS_PATH}}app2/templates/header.html','1-3')">
Example</a>.</p>

<a name="including"></a>

<h4>4 - JavaScript code and stylesheet of a template</h4>

<p>If a certain template has some javascript code or some special
styles of its own, then it is better to include them at the
beginning of the template (instead of including them globally, at
the &amp;lt;Head&amp;gt; of the page). This makes the template more
independent from the other parts of the page and thus easier to use
it again into another page. They are included like this:</p>
<pre>
    &amp;lt;script type="text/javascript" language="javascript" src="file.js"&amp;gt;&amp;lt;/script&amp;gt;
    &amp;lt;link type="text/css" rel="stylesheet" href="file.css"&amp;gt;
</pre>

<a href="javascript:codeReview('{{SAPPS_PATH}}app2/templates/footer.html','1')">
example1</a>, 
<a href="javascript:codeReview('{{SAPPS_PATH}}app2/templates/page3/tpl_2.html','1')">
example2</a>.

<p>The inclusion is much better than writing the JS and CSS code in
the template because it separates the HTML code from the JS and CSS
codes. It also is more efficient (has a better performance) because
the next time that this template is loaded in browser again, most
probably the browser will get "file.js" and "file.css" from its
cache, instead of retrieving them again from the server.</p>

<span class="button"><a href="#toc">TOC</a></span>
<hr />

<h3><a name="study">Study the sample</a></h3>

<p>Here we will highlight and discuss some of the features of the
sample application, so that we can understand it better.</p>

<ul>
  <li>All the templates of the application are placed in the folder
  <em>templates/</em>. We tell to the framework where to look for the
  templates by giving an appropriate value to the constant 
  <strong>TPL</strong>
  in the file 
  <a href="javascript:codeReview('{{SAPPS_PATH}}app2/config/const.Paths.php','6')">
  <em>config/const.Paths.php</em></a>.
  <br />
  <br /></li>

  <li>All the images of this application are placed in the folder
  <em>img/</em>. In templates they are linked using the 
  <strong>{{#IMG_URL}}</strong> variable. 
  <a href="javascript:codeReview('{{SAPPS_PATH}}app2/templates/footer.html','9,10')">
  See</a> how it is used. The <strong>{{#IMG_URL}}</strong> template 
  variable gets the value from the PHP constant <strong>IMG_URL</strong>, 
  which is declared in the file 
  <a href="javascript:codeReview('{{SAPPS_PATH}}app2/config/const.Paths.php','8')">
  <em>config/const.Paths.php</em></a>.
  <br />
  <br /></li>

  <li>All the files and templates of the page3 are placed in the
  folder <em>templates/page3/</em>. Organizing files into folders and
  subfolders reduces the complexity of the application and makes it
  easier to be understood and maintained. 
  <a href="javascript:codeReview('{{SAPPS_PATH}}app2/templates/footer.js','17')">
  Notice</a> how the transition to page3 is done.
  <br />
  <br /></li>

  <li>All the pages include the same header and footer template, e.g. see 
  <a href="javascript:codeReview('{{SAPPS_PATH}}app2/templates/page1.html','12,14')">
  page1.html</a>. If you want to change something in the footer of
  the page, then you don't have to change every page, but you make
  the change only once in the footer.
  <br />
  <br /></li>

  <li><a href="{{SAPPS_URL}}app2/browse.php" target="_blank">Browse</a>
  the files of the application and see the templates <em>page1.html</em>,
  <em>header.html</em>, <em>footer.html</em>, <em>page1_content.html</em>. 
  See them both in preview mode and in code view mode (select the "Code View"
  mode in the panel at the top and then click "Refresh").
  <br />
  <br /></li>

  <li>Browse the files and see the template <em>page2.html</em> and all
  the templates in the folder <em>templates/page3/</em>. See them both in
  preview mode and in code view mode. These two pages are the same
  in terms of what they display, however they are implemented
  differently in the server. <em>page2.html</em> is implemented as a flat
  big HTML file, while <em>page3.html</em> is structured, divided into
  several small subtemplates. Try to make the same modification in
  both of them and see which one is easier to be modified.
  <br />
  <br /></li>
</ul>

<span class="button"><a href="#toc">TOC</a></span>
<hr />

<h3><a name="exercises">Exercises</a></h3>

<p>Before starting the exercises, make a copy of the application
<em>app2</em> to the folder <em>test/app2</em>. If you have problems
with doing this (e.g. <em>test/app2</em> doesn't work) then see the
<a href="javascript:tabs3_select('tabs3::tutorial','transitions')">
first tutorial</a>, second exercise.</p>

<a name="exercise_1"></a>

<h4>1 - Modify page2.html and page3.html</h4>

<p>Change to red the color of the tpl_2_1 box, and change the text
inside it to "This box is red!".</p>

<p>Modify page2.html:</p>

<ol>
  <li>Open the file 
  <a href="javascript:codeReview('{{SAPPS_PATH}}app2/templates/page2.css','52,59')">
  page2.css</a> and change the color in the highlighted lines to
  <em>red</em>.</li>

  <li>Open the file 
  <a href="javascript:codeReview('{{SAPPS_PATH}}app2/templates/page2.html','64')">
  page2.html</a> and change the text in the highlighted lines to
  "This box is red!".</li>
</ol>

<p>Modify page3.html:</p>

<ol>
  <li>Open the file <a href=
  "javascript:codeReview('{{SAPPS_PATH}}app2/templates/page3/tpl_2_1.css','5,12','')">
  tpl_2_1.css</a> and change the color in the highlighted lines to
  <em>red</em>.</li>

  <li>Open the file <a href=
  "javascript:codeReview('{{SAPPS_PATH}}app2/templates/page3/tpl_2_1.html','5-6','')">
  tpl_2_1.html</a> and change the text in the highlighted line to
  "This box is red!".</li>
</ol>

<p>Which of the pages do you think is easier to be modified?</p>


<a name="exercise_2"></a>

<h4>2 - Rename folder <em>img</em> to <em>images</em></h4>

<ol>
  <li>Rename folder <em>img</em> to <em>images</em>: 
  <kbd>$ mv img images</kbd> <br />
  Test the application; the images will be broken.</li>

  <li>Change the value of the <strong>IMG_URL</strong> constant in the file
  <a href="javascript:codeReview('{{SAPPS_PATH}}app2/config/const.Paths.php','8')">
  const.Paths.php</a>. 
  Reload the application. The images should be alright.</li>
</ol>

<p>If all the images in the application are linked like this:
<kbd>&amp;lt;img src="{{#IMG_URL}}image_name.png"/&amp;gt;</kbd>
there will be no problem. However, if any image is hard linked
like this: <kbd>&amp;lt;img src="/img/image_name.png"/&amp;gt;</kbd>
it will not be displayed.</p>

<a name="exercise_3"></a>
<h4>3 - Divide Page1 further into subtemplates</h4>

<ol>
  <li>Open the file 
  <a href="javascript:codeReview('{{SAPPS_PATH}}app2/templates/page1_content.html','9-14')">
  page1_content.html</a> and copy the selected lines to the file
  <em>tpl_vars.html</em>.</li>

  <li>Replace the selected lines with this line: <br />
  <kbd>&amp;lt;Include src="{{#./}}tpl_vars.html"/&amp;gt;</kbd></li>

  <li>Copy the 
  <a href="javascript:codeReview('{{SAPPS_PATH}}app2/templates/page1_content.html','16-30','10-35')">
  selected lines</a> of <em>page1_content.html</em> to file
  <em>include_tag.html</em>, and replace them with: <br />
  <kbd>&amp;lt;Include src="{{#./}}include_tag.html"/&amp;gt;</kbd></li>

  <li>Copy the 
  <a href="javascript:codeReview('{{SAPPS_PATH}}app2/templates/page1_content.html','32-42','27-47')">
  selected lines</a> of <em>page1_content.html</em> to file
  <em>comments.html</em>, and replace them with: <br />
  <kbd>&amp;lt;Include src="{{#./}}comments.html"/&amp;gt;</kbd></li>

  <li>Copy the
  <a href="javascript:codeReview('{{SAPPS_PATH}}app2/templates/page1_content.html','44-63','40-70')">
  selected lines</a> of <em>page1_content.html</em> to file
  <em>js_code.html</em>, and replace them with: <br />
  <kbd>&amp;lt;Include src="{{#./}}js_code.html"/&amp;gt;</kbd></li>

  <li>Test that the application is OK.</li>
</ol>

<a name="exercise_4"></a>

<h4>4 - Move Page1 to a new folder</h4>

<p>If you make a listing of the folder <em>/templates/</em> you will see
that now there are a lot of files in it and it has started to
become messy. It would be better if we moved page1 files to another
folder.</p>

<ol>
  <li>Create new folder <em>page1</em>: <br />
  <kbd>$ mkdir page1</kbd></li>

  <li>Move files <em>page1.html</em>, <em>page1_content.html</em>,
  <em>tpl_vars.html</em>, <em>include_tags.html</em>, <em>comments.html</em>,
  <em>js_code.html</em> to folder <em>page1</em><br />
  e.g. <kbd>$ mv page1.html page1/</kbd></li>

  <li>If you test the application now, you will get an error. Open the file
  <a href="javascript:codeReview('{{SAPPS_PATH}}app2/config/const.Options.php','30-34')">
  <em>config/const.Options.php</em></a> and change the value of the constant
  <strong>FIRSTPAGE</strong> to "page1/page1.html".</li>

  <li>If you test the application now, it will not be able to find
  the stylesheet and the header and footer templates. Open the file
  <a href="javascript:codeReview('{{SAPPS_PATH}}app2/templates/page1.html','8,12,14','')">
  <em>page1/page1.html</em></a> and replace <strong>{{#./}}</strong> 
  with <strong>{{#TPL_URL}}</strong> for the stylesheet, and with
  <strong>{{#TPL}}</strong> for the templates, in the selected
  lines.</li>

  <li>There is still one more thing to fix: open 
  <a href="javascript:codeReview('{{SAPPS_PATH}}app2/templates/footer.js','5-8')">
  <em>footer.js</em></a>, modify <em>goto_page1()</em> and set the 
  <em>GoTo()</em> parameter to "page1/page1.html".</li>

  <li>Don't forget to refresh or reload the browser, so that it gets the
  change in <em>footer.js</em> (otherwise it may still use the cached, old
  version).</li>
</ol>


<a name="exercise_5"></a>

<h4>5 - Change the styles of the page1_content</h4>

<ol>
  <li>In the folder <em>templates/page1/</em> create the file
  <em>page1_content.css</em> which has these lines:
    <pre>
  h4 { color: red  }
  p  { color: blue }
</pre>
  </li>

  <li>At the top of the file <em>page1_content.html</em> add this line:
    <pre>
  &amp;lt;link rel="stylesheet" type="text/css" href="{{#./}}page1_content.css"&amp;gt;
</pre>
  </li>

  <li>Test the application and notice the changes in page1.</li>
</ol>


<a name="exercise_6"></a>

<h4>6 - Move template tpl_2.html to folder <em>page3/tpl_2/</em></h4>

<ol>
  <li>Create new folder <em>tpl_2</em>:<br />
  <kbd>$ cd templates/page3/ ; mkdir tpl_2</kbd></li>

  <li>Move the files <em>tpl_2.html</em>, <em>tpl_2.css</em>,
  <em>tpl_2_1.html</em>, <em>tpl_2_1.css</em>, <em>tpl_2_2.html</em>,
  <em>tpl_2_2.css</em> to the new folder: <br />
  <kbd>$ mv tpl_2*.* tpl_2</kbd></li>

  <li>Open the file
  <a href="javascript:codeReview('{{SAPPS_PATH}}app2/templates/page3/tmpl.html','11','')">
  tmpl.html</a> and change the <strong>SRC</strong> attribute of the include
  tag to <kbd>{{#./}}tpl_2/tpl_2.html</kbd>.</li>

  <li>Test the application and go to page3. It should be displayed
  correctly.</li>
</ol>

<p>Do yourself these changes as well:</p>

<ul>
  <li>Create a new folder <em>templates/page2/</em> and move the files
  <em>page2.html</em> and <em>page2.css</em> to it.</li>

  <li>Create a new folder <em>templates/page3/tpl_1</em> and move the
  files <em>tpl_1.html</em> and <em>tpl_1.css</em> to it.</li>

  <li>Create a new folder <em>templates/page3/tpl_2/tpl_2_1</em> and move
  the files <em>tpl_2_1.html</em> and <em>tpl_2_1.css</em> to it.</li>

  <li>Create a new folder <em>templates/page3/tpl_2/tpl_2_2</em> and move
  the files <em>tpl_2_2.html</em> and <em>tpl_2_2.css</em> to it.</li>
</ul>

<h4><a name="exercise_7">7 - Debug templates</a></h4>

<ol>
  <li>Open the file
  <a href="javascript:codeReview('{{SAPPS_PATH}}app2/config/const.Debug.php','39-43')">
  <em>config/const.Debug.php</em></a> and set the constant
  <strong>DEBUG_TEMPLATES</strong> to <em>true</em>.</li>

  <li>Refresh the application.</li>
</ol>

<h4><a name="exercise_8">8 - Think about it</a></h4>

<p>Suppose that you would like to add the current date at the top
of each file (without using JavaScript, using PHP). How would you
do it? Or, in general, how could you display something from PHP in
the page?</p>

<p><span class="button"><a href="#toc">TOC</a></span></p>
<hr />
